--
-- StopWaterDrive.lua
--
-- @author  MRA-Modding(Alex2009(www.alex2009.de))(www.mra-modding.de)
-- @date    14.12.2011
--

StopWaterDrive = {};

function StopWaterDrive.prerequisitesPresent(specializations)
    return true;
end;

function StopWaterDrive:load(xmlFile)
    self.brakeForceBackup = self.motor.brakeForce;
    self.InfoText = "Dieses Fahrzeug wurde vom StopWaterDrive system gestoppt.";
    self.InfoTextAdmin = "Halte Taste %s gedrueck um das Fahzeug aus dem Wasser zu fahren.";
    self.InfoTextUser = "Bitte sage dem Server Admin bescheit,\ndamit er das Fahzeug wieder aus dem Wasser holt.";
    if self.isServer then
        local DriveKey = InputBinding.getKeyNamesOfDigitalAction(InputBinding.DriveInWater);
        self.InfoText = self.InfoText.."\n"..string.format(self.InfoTextAdmin, DriveKey,RespawnKey);
    else
        self.InfoText = self.InfoText.."\n"..self.InfoTextUser;
    end;
    self.isInWater = false;
    self.DriveKeyPressed = false;
end;

function StopWaterDrive:delete()
end;

function StopWaterDrive:mouseEvent(posX, posY, isDown, isUp, button)
end;

function StopWaterDrive:keyEvent(unicode, sym, modifier, isDown)
end;

function StopWaterDrive:update(dt)
    if self:getIsActiveForInput() then
        if self.isServer then
            if InputBinding.isPressed(InputBinding.DriveInWater) then	
                self.DriveKeyPressed = true;
            elseif not InputBinding.isPressed(InputBinding.DriveInWater) and self.DriveKeyPressed then	
                self.DriveKeyPressed = false;
            end;
        end;
    end;
end;

function StopWaterDrive:updateTick(dt)
    local xt,yt,zt = getTranslation(self.components[1].node);
    local deltaWater = yt-g_currentMission.waterY+2.5;
    if deltaWater < 2.6 and not self.DriveKeyPressed then
        self.isInWater = true;
        local brakeTorque = 999;
        self.motor.brakeForce = brakeTorque;
        if self.isServer then
            acceleration = 0;
            self.lastAcceleration = 0;
            WheelsUtil.updateWheelsPhysics(self, dt, 0, acceleration, false, self.requiredDriveMode);
            for k,wheel in pairs(self.wheels) do
                setWheelShapeProps(wheel.node, wheel.wheelShape, 0, brakeTorque, 0);
            end;
        end;
    else
        self.isInWater = false;
        if self.motor.brakeForce ~= self.brakeForceBackup then
            self.motor.brakeForce = self.brakeForceBackup;
        end;
    end;
end;

function StopWaterDrive:draw()
    if not self.DriveKeyPressed and self.isInWater then
        g_currentMission:addWarning(self.InfoText, 0.010, 0.020);
    end;
end;
